local mod = RW:Boss("Saviana Ragefire", "The Ruby Sanctum")
local L

mod:SetPackIcon([[Interface\ICONS\spell_nature_elementalprecision_2]])
mod.BossIcon = [[Interface\Icons\spell_shadow_twilight]]

---------------------------
-- Variables

-- Enrage
local tEnrageDur, wEnrage, tEnrageCD

-- Conflagration
local wConflagOnYou, wConflagClose, tConflagCD, mConflag, iConflag

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.conflag_close = "Conflagration target close!"
		L.conflag_close_opt = "Warning when the target is close to you."
		
		L.say_conflag = "\"Say-message\" when you are the target of Conflagration"
	end
	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(39747)
	self:SetWin()
	
	self:AddBoolOption("SayOnConflag", L.say_conflag, nil, true, select(3, GetSpellInfo(74452)))
	
	-- Enrage
	tEnrageCD			= mod:CDTimer(20, 78722)
	tEnrageDur			= mod:DurTimer(10, 78722)
	wEnrage				= mod:CastWarning(78722)
	
	-- Conflagration
	tConflagCD			= mod:CDTimer(35, 74452)
	wConflagClose		= mod:CustomWarning(L.conflag_close, L.conflag_close_opt, 74452)
	wConflagOnYou		= mod:OnYouWarning(74452)
	mConflag			= mod:TargetMessage(74452)
	iConflag			= mod:Icon("SKULL", 74452, false, 10)
end

---------------------------
-- Locals

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("Enrage", 78722)
	self:Track("Conflag", 74452)
end

function mod:Enrage(event, args)
	if event == "SPELL_AURA_APPLIED" then
		tEnrageDur:Start()
		wEnrage:Show()
		tEnrageCD:Start()
		
	elseif event == "SPELL_AURA_REMOVED" then
		tEnrageDur:Stop()
	end
end

function mod:ConflagTarget()
	local target = self:GetMobTarget()
	if target then
		if target == self.pName then
			wConflagOnYou:Show()
			if self.db.profile.SayOnConflag then
				SendChatMessage("Conflagration on ME!", "SAY")
			end
		end
		
		if self.Party.group[target] then
			local uID = self.Party.group[target].id
			if uID and CheckInteractDistance(uID, 3) then
				wConflagClose:Show()
			end
		end
		
		iConflag:Show(target)
	end
end

function mod:Conflag(event, args)
	if event == "SPELL_CAST_START" then
		tConflagCD:Start()
		self:Schedule("ConflagTargetScan", 0.1, "ConflagTarget")
	end
end

